(***************************************************************************)
(*                              MPC 2012                                   *)
(*                                                                         *)
(*                                                                         *)
(* Authors: Louis Mandel (louis.mandel@lri.fr)                             *)
(*          Florence Plateau (florence.plateau@lri.fr)                     *)
(*                                                                         *)
(* Creation date: April 2012                                               *)
(*                                                                         *)
(***************************************************************************)

(** Misc functions.

    @author Louis Mandel
    @author Florence Plateau
*)

(** Greatest common divisor. *)
let rec gcd a b =
  if  a = 0 then b
  else if b = 0 then a
  else let r = a mod b in
  if r = 0 then b else gcd b r

(** Least common multiple. *)
let lcm a b =
  if (a = 0) || (b = 0)
  then 0
  else if (a mod b = 0) then a
  else if (b mod a = 0) then b
  else (a * b) / (gcd a b);;

(** Print a list of elements. *)
let rec fprint_list sep print ff l =
  match l with
  | [] -> ()
  | [x] -> print ff x
  | x :: l -> Format.fprintf ff "%a%(%)%a" print x sep (fprint_list sep print) l
